package com.jz.dmp.modules.service;

import java.util.List;

import com.jz.common.enums.ModuleLogEnum;
import com.jz.dmp.modules.model.DmpModuleOperateLog;

public interface DmpModuleOperateLogService {

    /**
     * 新增记录
     *
     * @param operateLog
     * @param moduleEnum
     * @throws Exception
     */
    public void addRecord(DmpModuleOperateLog operateLog, ModuleLogEnum moduleEnum) throws Exception;

    /**
     * 获取最新操作日志
     *
     * @param primaryKey    必填
     * @param moduleLogEnum 必填
     * @return
     * @throws Exception
     */
    public DmpModuleOperateLog getLastOperateLog(Integer primaryKey, ModuleLogEnum moduleLogEnum) throws Exception;

    /**
     * 写入同步xml提交版本信息
     *  @param primaryKey 必填
     * @param xmlContent 必填
     */
    public DmpModuleOperateLog writeSubmitXmlVersion(Integer primaryKey, String xmlContent) throws Exception;

    /**
     * 读取提交的同步xml历史版本列表
     *
     * @param primaryKey 必填
     * @return
     */
    public List<DmpModuleOperateLog> readSubmitXmlVersion(Integer primaryKey) throws Exception;

}
