package com.jz.dmp.modules.service.sys.impl;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.scheduling.support.CronSequenceGenerator;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSONObject;
import com.jz.common.bean.BaseBeanResponse;
import com.jz.common.constant.CommConstant;
import com.jz.common.constant.StatuConstant;
import com.jz.common.utils.HttpRequestUtil;
import com.jz.dmp.modules.service.sys.SystemCommonService;

/**
 * @ClassName: SystemCommonServiceImpl
 * @Description: TODO(公共服务实现类)
 * @author ybz
 * @date 2021年1月25日
 *
 */
@Service
public class SystemCommonServiceImpl implements SystemCommonService {

	/**
	 *获取重复提交校验token
	 */
	@Override
	public BaseBeanResponse<String> getResubmitToken(HttpServletRequest httpRequest) throws Exception {
		BaseBeanResponse<String> baseBeanResponse = new BaseBeanResponse<String>();
		
		String resubmitToken =  HttpRequestUtil.getResubmitToken(httpRequest);
		
		baseBeanResponse.setCode(StatuConstant.SUCCESS_CODE);
		baseBeanResponse.setMessage("获取成功");
		baseBeanResponse.setData(resubmitToken);
		
		return baseBeanResponse;
	}

	@Override
	public BaseBeanResponse<String> getCornTimes(String corn, HttpServletRequest httpRequest) throws Exception {
		
		BaseBeanResponse<String> baseBeanResponse = new BaseBeanResponse<String>();
		
		//CronSequenceGenerator cronSequenceGenerator = new CronSequenceGenerator("* * * * * ?");
		corn = corn.replace("/", "0/");
		CronSequenceGenerator cronSequenceGenerator = new CronSequenceGenerator(corn);

		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

		List<String> list = new ArrayList<String>(10);

		Date nextTimePoint = new Date();
		
		for (int i = 0; i < 10; i++) {
			nextTimePoint = cronSequenceGenerator.next(nextTimePoint);
			list.add(sdf.format(nextTimePoint));
		}
		
		baseBeanResponse.setCode(StatuConstant.SUCCESS_CODE);
		baseBeanResponse.setMessage("生成成功");
		baseBeanResponse.setDatas(list);
		return baseBeanResponse;
	}
	
	public static void main(String[] args) {
		CronSequenceGenerator cronSequenceGenerator = new CronSequenceGenerator("0 1-3 * * * ?");

		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

		List<String> list = new ArrayList<String>(10);

		Date nextTimePoint = new Date();
		
		for (int i = 0; i < 10; i++) {
			nextTimePoint = cronSequenceGenerator.next(nextTimePoint);
			list.add(sdf.format(nextTimePoint));
		}
		System.out.println(JSONObject.toJSONString(list));
	}

}
